#!/bin/bash


# creazione e uso di filesystem con blocchi 128 1024 2048 4096 
sizelist="128 1024 2048 4096"
NBLOCK=40


for SIZE in $sizelist ; do
# pulizia della directory ./tmp
	    rm -fr ./tmp/*
# creazione nuovo filesystem
	if ! ./sfat_create "./tmp/fsf" $NBLOCK $SIZE ; then
	    echo "$0: nblock $NBLOCK size $SIZE creazione non effettuta." 
	elif [ -e "./tmp/fsf" ] ; then
	    echo "$0:  nblock $NBLOCK size $SIZE creato OK"
# attivazione server
	    ./server "./tmp/fsf"  2>serverlogpar &
	    sleep 1
#test sfat_mkdir
	    ./sfat_mkdir /D1 > .aa &
	    ./sfat_mkdir /D2 > .ab &
	    ./sfat_mkdir /D3 > .ac &
	    wait %2
	    wait %3
	    wait %4
	    ./sfat_mkdir /D3/D33 > .ad
	    ./sfat_ls /D3 > .ae &
	    ./sfat_ls /D1 > .af &
	    ./sfat_ls /D2 > .ag &
	    ./sfat_mkfile /D3/D33/f1 > .ah &
	    ./sfat_mkfile /D3/D33/f2 > .ai &
	    ./sfat_mkfile /D3/D33/f3 > .al &
	    wait %2
	    wait %3
	    wait %4	    
	    wait %5	    
	    wait %6	    
	    wait %7	    
            ./sfat_append /D3/D33/f1 "pippo pluto e paperone:uuuuuuuuuuuu"
	    ./sfat_read /D3/D33/f1 0 256 > .am &
	    ./sfat_read /D3/D33/f1 0 256 > .an &
	    ./sfat_read /D3/D33/f1 0 256 > .ao &
	    wait %2
	    wait %3
	    wait %4	    
#test di cp	    
	    ./sfat_cp /D3/D33/f1 /D3/D33/g1 > .ap &
	    ./sfat_cp /D3/D33/f1 /D3/D33/h1 > .aq &
	    ./sfat_cp /D3/D33/f1 /D3/D33/j1 > .ar &
	    wait %2
	    wait %3
	    wait %4
	    ./sfat_read /D3/D33/f1 0 100 > a
	    ./sfat_read /D3/D33/g1 0 100 | tr 'g' 'f' > b
	    if  ! diff a b ; then
		exit 1
	    fi
	    ./sfat_read /D3/D33/f1 0 100 > a
	    ./sfat_read /D3/D33/h1 0 100 | tr 'h' 'f' > b
	    if  ! diff a b ; then
		exit 1
	    fi
	    ./sfat_read /D3/D33/f1 0 100 > a
	    ./sfat_read /D3/D33/j1 0 100 | tr 'j' 'f' > b
	    if  ! diff a b ; then
		exit 1
	    fi
# test terminazione
	    if ! killall -PIPE server; then
		echo SIGPIPE non gestito
		exit 1
	    fi
	    if  ! killall -TERM server; then
		echo SIGTERM non gestito
		exit 1
	    fi
	    wait %1
	else
	    echo "$0: nblock $NBLOCK size $SIZE creazione non effettuta"
	    exit 1
	fi
	
    done
exit 0




