#!/bin/bash

# invocazioni errate di sfat_create
if  ./sfat_create "./tmp/fs1" ; then
    echo "$0: Invocazione errata non riconosciuta." 
    exit 1
fi

if  ./sfat_create "./tmp/fs1" 20 256 ; then
    echo "$0: Invocazione errata non riconosciuta."
    exit 1
fi

if  ./sfat_create "./tmp/fs1" -20 256 ; then
    echo "$0: Invocazione errata non riconosciuta."
    exit 1
fi

# creiamo il primo filesystem
if ! ./sfat_create "./tmp/fs1" 200 128 ; then
    echo "$0: Invocazione corretta non effettuta."
    exit 1
fi
if [ -e "./tmp/fs1" ] ; then
    echo "$0: ./tmp/fs1: creato OK"
else
    echo "$0: ./tmp/fs1: non creato correttamente"
    exit 1
fi



# filesystem gia' esistente
if ./sfat_create "./tmp/fs1" 200 128 ; then
    echo "$0: Invocazione scorretta effettuta."
    exit 1
fi

# creazione e uso di filesystem con blocchi 128 1024 2048 4096 
sizelist="128 1024 2048 4096"
NBLOCK=40


for SIZE in $sizelist ; do
# pulizia della directory ./tmp
	    rm -fr ./tmp/*
# creazione nuovo filesystem
	if ! ./sfat_create "./tmp/fsf" $NBLOCK $SIZE ; then
	    echo "$0: nblock $NBLOCK size $SIZE creazione non effettuta." 
	elif [ -e "./tmp/fsf" ] ; then
	    echo "$0:  nblock $NBLOCK size $SIZE creato OK"
# attivazione server
	    ./server "./tmp/fsf"  2>serverlog$SIZE &
	    sleep 1
#test sfat_mkdir
	    if  ./sfat_mkdir /Dhhhjjjjjjkkll ; then
		echo "$0: Errore il nome Dhhhjjjjjjkkll e' piu' lungo di 8 caratteri"
	    fi    
	    if  ./sfat_mkdir ./Dkll ; then
		echo "$0: Errore pathname relativo non ammesso"
	    fi
# creazione e listing di un albero di directory
	    ./sfat_mkdir /D1 
	    ./sfat_ls / 
	    ./sfat_ls /D1
	    ./sfat_mkdir /D2
	    ./sfat_ls /
	    ./sfat_ls /D2
	    ./sfat_mkdir /D3
	    ./sfat_ls /
	    ./sfat_ls /D3
	    ./sfat_mkdir /D3/D31
	    ./sfat_ls /
	    ./sfat_ls /D1
	    ./sfat_mkdir /D3/D32
	    ./sfat_mkdir /D3/D33
	    ./sfat_mkdir /D3/D33/D_kl
	    ./sfat_mkdir /D3/D33/D_nn
	    ./sfat_ls /D3
	    ./sfat_ls /D3/D32
	    ./sfat_ls /D3/D33
# test della mkfile
	    ./sfat_mkfile /D3/D33/D_nn/f1
	    ./sfat_mkfile /D3/D33/D_nn/f2
	    ./sfat_mkfile /D3/D33/D_nn/f3
	    ./sfat_ls /D3/D33/D_nn
	    if ./sfat_mkfile /D3/D33/D_nn/f1 ; then
		echo "$0: Error: file /D3/D33/D_nn/f1 already present"
	    fi
# test di append e read
            # su file non esistente
	    if ./sfat_append /D3/D33/D_nn/f "pippo pluto e paperone:" ; then
		echo "$0: Error: file /D3/D33/D_nn/f non esiste"
	    fi
	    # su file esistente
            ./sfat_append /D3/D33/D_nn/f1 "pippo pluto e paperone:"
	    ./sfat_read /D3/D33/D_nn/f1 0 256
# test : non posso leggere oltre la fine del file
	    if ./sfat_read /D3/D33/D_nn/f1 256 256; then
		echo "$0: Error: lettura fuori dal file /D3/D33/D_nn/f1"
	    else
		echo "$0: OK: evitata lettura fuori dal file /D3/D33/D_nn/f1"
	    fi
# test di append multiple
	    ILIST="1 2 3 4 5 6"
	    for I in $ILIST ; do
		./sfat_append /D3/D33/D_nn/f1 "pippo pluto e paperone$I:"
	    done
# rileggo il file
	    ./sfat_read /D3/D33/D_nn/f1 0 1024
# rileggo parti del file ottenuto con le precedenti append
	    ILIST="0 10 20 30 40 50"
	    for I in $ILIST ; do
		./sfat_read /D3/D33/D_nn/f1 $I 10
	    done
#test di cp	    
	    ./sfat_cp /D3/D33/D_nn/f1 /D3/D33/D_nn/g1
# rilettura e confronto file
	    ./sfat_read /D3/D33/D_nn/g1 0 1024
	    for I in $ILIST ; do
# controllo che la rilettura dia lo stesso identico risultato
		./sfat_read /D3/D33/D_nn/f1 $I 10 > a
		./sfat_read /D3/D33/D_nn/g1 $I 10 | tr 'g' 'f' > b
		if  ! diff a b ; then
		    exit 1
		fi
	    done
# test terminazione e gestione segnali
	    if ! killall -PIPE server; then
		echo SIGPIPE non gestito
		exit 1
	    fi
	    if  ! killall -TERM server; then
		echo SIGTERM non gestito
		exit 1
	    fi
	    wait %1
	else
	    echo "$0: nblock $NBLOCK size $SIZE creazione non effettuta"
	    exit 1
	fi
	
    done
exit 0




