/** 
 *  \file 
 *  \brief Creazione e formattazione del file system SFAT
 *  \author lcs07
 *
 */

/**
 * Questa funzione ha il compito di formattare un file con il formato
 * SFAT. In particolare deve realizzare le seguenti operazioni:
 *
 *
 * - Scrittura dei dati nel boot sector.
 * - Inizializzazione della File Allocation Table.
 * - Inizializzazione della Directory Table.
 *
 * \param fs puntatore al file che conterra' il file system e che deve quindi essere formattato
 * \param block_size size di ciascun blocco (in byte)
 * \param num_block numero di blocchi disponibili
 * \return 
 *         - EWFCD se si verifica un errore durante la scrittura
 *           delle strutture dati utilizzate dalla SFAT.
 *         - 0 se la formattazione si e' conclusa con successo
 */
int fat_format (FILE *fs, int block_size, unsigned int num_block);
