#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mkdir_suite.h"
#include "CUnit.h"
#include "TestDB.h"
#include "Basic.h"
#include "mkdir_suite.h"
#include "format_suite.h"
#include "rw_suite.h"
#include "open_suite.h"


/**
 * @file
 * \test
 *
 * Consente di eseguire tutte le test suites per il progetto 
 * SFAT.
 */
int main(int argc, char* argv[])
{
    CU_BasicRunMode mode = CU_BRM_VERBOSE;
    unsigned int retval=0;

    if (CU_initialize_registry()) 
	printf("\nInitialization of Test Registry failed.");
    
    add_suite_format();
    add_suite_mkdir();
    add_suite_open();
    add_suite_rw();
    
    CU_basic_set_mode(mode);
    printf("\nTests completed with return value %d.\n", CU_basic_run_tests());
    printf("\nTests completed: with %d failures.\n", retval = CU_get_number_of_tests_failed());
    CU_cleanup_registry();

    return retval;

}
